<!DOCTYPE html>
<html lang="en">

<head>
	<meta charset="UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/semantic-ui/2.4.1/semantic.min.css">
	<link rel="stylesheet" type="text/css"
		href="https://cdn.jsdelivr.net/npm/daterangepicker@3.1.0/daterangepicker.css">
	<script src="https://code.jquery.com/jquery-3.1.1.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/semantic-ui/2.4.1/semantic.min.js"></script>
	<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker@3.1.0/moment.min.js"></script>
	<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker@3.1.0/daterangepicker.min.js">
	</script>
	<script src="cookie.js"></script>
	<script src="session.js"></script>
	</script>

	<title>Call History</title>
</head>

<script>
	isAdmin = getAdminCookie();
	if (!isAdmin) {
		window.location.href = 'login.html';
	}

	checkUserSessionAndRedirect("login.html");
</script>

<body>
	<br>
	<button style="float:right;" class="ui button primary" onclick="downloadCSV()">Download CSV</button>

	<div class="ui container"">
		<h2 class=" ui header">Call History</h2>

		<div style="display: flex; align-items: center; margin-bottom: 20px;">
			<div style="margin-right: 20px;">
				<label style="font-size: 14px;">Search:</label>
				<div class="ui small input">
					<input type="text" placeholder="Search..." id="searchInput">
				</div>
			</div>

			<div style="margin-right: 20px;">
				<label style="font-size: 14px;">Date range:</label>
				<div class="ui labeled input">
					<input type="text" id="dateRangeInput" style="width: 300px;">
				</div>
			</div>

			<button class="ui button" onclick="fetchCallData(1)">Search Now</button>
		</div>

		<table class="ui celled table" id="callTable">
			<thead>
				<tr>
					<th>Channel</th>
					<th>Call ID</th>
					<th>Caller Name</th>
					<th>Caller Number</th>
					<th>Callee Name</th>
					<th>Callee Number</th>
					<th style="width: 150px;">Started At</th>
					<th style="width: 150px;">Finished At</th>
					<th>Talk Time</th>
				</tr>
			</thead>
			<tbody>
				<!-- Calls will be dynamically added here -->
			</tbody>
		</table>

		<div class="ui pagination menu" id="pagination"></div>
	</div>

	<script>
		$(document).ready(function () {
			// Initialize date range picker
			$('#dateRangeInput').daterangepicker({
				opens: 'left',
				autoUpdateInput: false,
				startDate: moment().startOf('day'),
				endDate: moment().endOf('day'),
				locale: {
					format: 'DD MMM YYYY HH:mm',
				}
			});

			// Set the initial value in the input field
			$('#dateRangeInput').val(
				moment().startOf('day').format('DD MMM YYYY HH:mm') +
				' - ' +
				moment().endOf('day').format('DD MMM YYYY HH:mm')
			);

			// Update the input field when a date range is selected
			$('#dateRangeInput').on('apply.daterangepicker', function (ev, picker) {
				$(this).val(picker.startDate.format('DD MMM YYYY HH:mm') + ' - ' + picker.endDate.format(
					'DD MMM YYYY HH:mm'));
			});

			fetchCallData(1);
		});

		function fetchCallData(page) {
			var serverEndpoint = 'http://127.0.0.1:20000/call_history';
			var itemsPerPage = 10;
			var searchValue = $('#searchInput').val().toLowerCase();
			var dateRangePicker = $('#dateRangeInput').data('daterangepicker');

			// Get the selected start and end dates in Unix timestamp format
			var fromTimestamp = dateRangePicker.startDate.unix();
			var toTimestamp = dateRangePicker.endDate.unix();

			$.ajax({
				url: serverEndpoint,
				type: 'GET',
				data: {
					page: page,
					search: searchValue,
					from: fromTimestamp,
					to: toTimestamp,
					search: searchValue
				},
				success: function (data) {
					var result = JSON.parse(data);
					renderCallTable(result.Calls);

					var totalPages = Math.ceil(result.total / itemsPerPage);
					renderPagination(totalPages, page);
				},
				error: function () {
					console.log('Error fetching data from the server.');
				}
			});
		}

		function renderCallTable(calls) {
			var tbody = $('#callTable tbody');
			tbody.empty(); // Clear existing rows
			if (!calls) {
				return;
			}

			calls.forEach(function (call) {
				var talkTime = call.finished_at - call.started_at;

				var row = $('<tr>');
				row.append($('<td>').text(call.channel.trim()));
				row.append($('<td>').text(call.call_id.trim()));
				row.append($('<td>').text(call.caller_name.trim()));
				row.append($('<td>').text(call.caller_number.trim()));
				row.append($('<td>').text(call.callee_name.trim()));
				row.append($('<td>').text(call.callee_number.trim()));
				row.append($('<td>').text(formatDateTime(call.started_at)));
				row.append($('<td>').text(formatDateTime(call.finished_at)));
				row.append($('<td>').text(formatTalkTime(talkTime)));

				tbody.append(row);
			});
		}

		function renderPagination(totalPages, currentPage) {
			if (totalPages === 0) {
				return;
			}

			var paginationMenu = $('#pagination');
			paginationMenu.empty(); // Clear existing pages

			var displayPages = 3; // Number of pages to display

			var startPage = Math.max(1, currentPage - Math.floor(displayPages / 2));
			var endPage = Math.min(totalPages, startPage + displayPages - 1);

			if (currentPage <= displayPages - Math.floor(displayPages / 2)) {
				endPage = Math.min(displayPages, totalPages);
			}

			for (var i = startPage; i <= endPage; i++) {
				var pageItem = $('<a class="item">').text(i);

				if (i === currentPage) {
					pageItem.addClass('active');
				} else {
					pageItem.data('page', i); // Store the page number as data

					pageItem.click(function () {
						var clickedPage = $(this).data('page');

						// Remove the 'active' class from all page items
						paginationMenu.find('.item').removeClass('active');

						// Add the 'active' class to the clicked page item
						paginationMenu.find('.item[data-page="' + clickedPage + '"]').addClass('active');

						// Fetch data for the clicked page
						fetchCallData(clickedPage);
					});
				}

				paginationMenu.append(pageItem);
			}

			// Add ellipsis for additional pages
			if (endPage < totalPages) {
				paginationMenu.append('<span class="item">...</span>');
			}

			// Add the last page
			if (endPage < totalPages) {
				var lastPageItem = $('<a class="item">').text(totalPages);
				lastPageItem.data('page', totalPages);

				lastPageItem.click(function () {
					var clickedPage = $(this).data('page');

					// Remove the 'active' class from all page items
					paginationMenu.find('.item').removeClass('active');

					// Add the 'active' class to the clicked page item
					paginationMenu.find('.item[data-page="' + clickedPage + '"]').addClass('active');

					// Fetch data for the clicked page
					fetchCallData(clickedPage);
				});

				paginationMenu.append(lastPageItem);
			}

			// Add the 'Next' button
			var nextPageItem = $('<a class="item">').text('Next');
			nextPageItem.click(function () {
				var next = currentPage + 1;

				if (next <= totalPages) {
					// Remove the 'active' class from all page items
					paginationMenu.find('.item').removeClass('active');

					// Add the 'active' class to the next page item
					paginationMenu.find('.item[data-page="' + next + '"]').addClass('active');

					// Fetch data for the next page
					fetchCallData(next);
				}
			});

			paginationMenu.append(nextPageItem);
		}

		function formatTalkTime(seconds) {
			var hours = Math.floor(seconds / 3600);
			var minutes = Math.floor((seconds % 3600) / 60);
			var remainingSeconds = seconds % 60;

			return (
				padWithZero(hours) + ':' +
				padWithZero(minutes) + ':' +
				padWithZero(remainingSeconds)
			);
		}

		function padWithZero(number) {
			return (number < 10 ? '0' : '') + number;
		}

		function downloadCSV() {
			var serverEndpoint = 'http://127.0.0.1:20000/csv_call_history';
			var searchValue = $('#searchInput').val().toLowerCase();
			var dateRangePicker = $('#dateRangeInput').data('daterangepicker');

			// Get the selected start and end dates in Unix timestamp format
			var fromTimestamp = dateRangePicker.startDate.unix();
			var toTimestamp = dateRangePicker.endDate.unix();

			// Construct the CSV download URL
			var csvURL = `${serverEndpoint}?search=${searchValue}&from=${fromTimestamp}&to=${toTimestamp}&search=${searchValue}`;

			// Use AJAX to fetch the data from the server
			$.ajax({
				url: csvURL,
				type: 'GET',
				success: function (data) {
					var result = JSON.parse(data);
					var csvContent = createCSV(result.Calls);
					// Create a Blob containing the CSV data
					var blob = new Blob([csvContent], {
						type: 'text/csv'
					});

					// Create a link element to download the CSV file
					var link = document.createElement('a');
					link.href = window.URL.createObjectURL(blob);

					// Set the link's download attribute with a desired filename
					link.download = 'call_history.csv';

					// Append the link to the document body
					document.body.appendChild(link);

					// Trigger a click event on the link to start the download
					link.click();

					// Remove the link from the document body
					document.body.removeChild(link);
				},
				error: function () {
					console.log('Error fetching CSV data from the server.');
				}
			});
		}

		function createCSV(calls) {
			if (!calls) {
				return;
			}

			var csvContent =
				'Channel,Call ID,Caller Name,Caller Number,Callee Name,Callee Number,Started At,Finished At,Talk Time\n';

			calls.forEach(function (call) {
				var talkTime = call.finished_at - call.started_at;
				ttime = formatTalkTime(talkTime);
				// Add data rows

				csvContent +=
					`${call.channel.trim()},${call.call_id.trim()},${call.caller_name.trim()},${call.caller_number.trim()},${call.callee_name.trim()},${call.callee_number.trim()},${formatDateTime(call.started_at)},${formatDateTime(call.finished_at)},${ttime}\n`;
			});

			return csvContent;
		}

		function formatDateTime(timestamp) {
			var date = new Date(timestamp * 1000);
			var formattedDate = date.toISOString().split('T')[0]; // Get date part only
			var formattedTime = date.toTimeString().split(' ')[0]; // Get time part only
			return `${formattedDate} ${formattedTime}`;
		}
	</script>
</body>

</html>